namespace CMSMicroservice.Application.NetworkMembershipCQ.Queries.GetUserNetworkPosition;

public class GetUserNetworkPositionQueryValidator : AbstractValidator<GetUserNetworkPositionQuery>
{
    public GetUserNetworkPositionQueryValidator()
    {
        RuleFor(x => x.UserId)
            .GreaterThan(0)
            .WithMessage("شناسه کاربر معتبر نیست");
    }

    public Func<object, string, Task<IEnumerable<string>>> ValidateValue => async (model, propertyName) =>
    {
        var result = await ValidateAsync(
            ValidationContext<GetUserNetworkPositionQuery>.CreateWithOptions(
                (GetUserNetworkPositionQuery)model,
                x => x.IncludeProperties(propertyName)));

        if (result.IsValid)
            return Array.Empty<string>();

        return result.Errors.Select(e => e.ErrorMessage);
    };
}
